
class Grenade_Incen extends Grenade_Smoke;

//1st Person
#exec MESH MODELIMPORT MESH=GrenadeIncenMesh MODELFILE=ModelsSkeletal\Grenades\GrenadeSmoke\GrenadeFlashMesh.psk
#exec MESH ORIGIN MESH=GrenadeIncenMesh X=0 Y=0 Z=0 YAW=-64 PITCH=0 ROLL=0

//Pickup
#exec MESH IMPORT MESH=GrenadeIncenFirstPick ANIVFILE=MODELS\Grenades\GrenadeSmoke\GrenadeFlashFirstPick_a.3d DATAFILE=MODELS\Grenades\GrenadeSmoke\GrenadeFlashFirstPick_d.3d X=0 Y=0 Z=0
#exec MESH ORIGIN MESH=GrenadeIncenFirstPick X=0 Y=-60 Z=25.5

//3rd Person
#exec MESH IMPORT MESH=GrenadeIncenFirst3rd ANIVFILE=MODELS\Grenades\GrenadeSmoke\GrenadeFlashFirst3rd_a.3d DATAFILE=MODELS\Grenades\GrenadeSmoke\GrenadeFlashFirst3rd_d.3d X=0 Y=0 Z=0
#exec MESH ORIGIN MESH=GrenadeIncenFirst3rd X=0 Y=7 Z=-5 Yaw=64

//Animations
//1st Person
#exec ANIM IMPORT ANIM=GrenadeSmokeMeshAnims ANIMFILE=ModelsSkeletal\Grenades\GrenadeSmoke\GrenadeFlashMeshAnims.psa COMPRESS=1

#exec ANIM SEQUENCE ANIM=GrenadeSmokeMeshAnims SEQ=All STARTFRAME=0 NUMFRAMES=98
#exec ANIM SEQUENCE ANIM=GrenadeSmokeMeshAnims SEQ=Select STARTFRAME=0 NUMFRAMES=22
#exec ANIM SEQUENCE ANIM=GrenadeSmokeMeshAnims SEQ=Still STARTFRAME=23 NUMFRAMES=9
#exec ANIM SEQUENCE ANIM=GrenadeSmokeMeshAnims SEQ=PullPin STARTFRAME=33 NUMFRAMES=40
#exec ANIM SEQUENCE ANIM=GrenadeSmokeMeshAnims SEQ=Throw STARTFRAME=74 NUMFRAMES=24

#exec ANIM DIGEST ANIM=GrenadeSmokeMeshAnims
#exec MESH DEFAULTANIM MESH=GrenadeIncenMesh ANIM=GrenadeSmokeMeshAnims

//Pickup
#exec MESH SEQUENCE MESH=GrenadeIncenFirstPick SEQ=All 		STARTFRAME=0 NUMFRAMES=1
#exec MESH SEQUENCE MESH=GrenadeIncenFirstPick SEQ=Still 	STARTFRAME=0 NUMFRAMES=1
#exec MESH SEQUENCE MESH=GrenadeIncenFirstPick SEQ=Select 	STARTFRAME=0 NUMFRAMES=1

//3rd Person
#exec MESH SEQUENCE MESH=GrenadeIncenFirst3rd SEQ=All STARTFRAME=0 NUMFRAMES=1
#exec MESH SEQUENCE MESH=GrenadeIncenFirst3rd SEQ=Still STARTFRAME=0 NUMFRAMES=1

//Scales
//1st Person
#exec MESHMAP SCALE MESHMAP=GrenadeIncenMesh X=1.0 Y=1.0 Z=1.0

//Pickup
#exec MESHMAP NEW MESHMAP=GrenadeIncenFirstPick MESH=GrenadeIncenFirstPick
#exec MESHMAP SCALE MESHMAP=GrenadeIncenFirstPick X=0.1 Y=0.1 Z=0.2

//3rd Person
#exec MESHMAP NEW MESHMAP=GrenadeIncenFirst3rd MESH=GrenadeIncenFirst3rd
#exec MESHMAP SCALE MESHMAP=GrenadeIncenFirst3rd X=0.1 Y=0.1 Z=0.2

//Textures
#exec TEXTURE IMPORT NAME=GrenadeIncenBody FILE=Textures\Grenades\GrenadeIncen\GrenadeIncenBody.bmp GROUP=IncenSmoke LODSET=2
#exec TEXTURE IMPORT NAME=GrenadeSmokeMeshSkin01 FILE=Textures\Generic\M3Arm.bmp GROUP=Generic LODSET=2
#exec TEXTURE IMPORT NAME=GrenadeSmokeMeshSkin02 FILE=Textures\Generic\M3Gloves.bmp GROUP=Generic LODSET=2
#exec TEXTURE IMPORT NAME=GrenadeSmokeMeshSkin03 FILE=Textures\Generic\M3Thumbs.bmp GROUP=Generic LODSET=2

#exec TEXTURE IMPORT NAME=GrenadeIncenBodyPick FILE=Textures\Grenades\GrenadeIncen\GrenadeIncenBodyPick.bmp GROUP=IncenSmoke LODSET=2

//1st Person
#exec MESHMAP SETTEXTURE MESHMAP=GrenadeIncenMesh NUM=0 TEXTURE=GrenadeIncenBody
#exec MESHMAP SETTEXTURE MESHMAP=GrenadeIncenMesh NUM=1 TEXTURE=GrenadeSmokeMeshSkin01
#exec MESHMAP SETTEXTURE MESHMAP=GrenadeIncenMesh NUM=2 TEXTURE=GrenadeSmokeMeshSkin02
#exec MESHMAP SETTEXTURE MESHMAP=GrenadeIncenMesh NUM=3 TEXTURE=GrenadeSmokeMeshSkin03

//Pickup
#exec MESHMAP SETTEXTURE MESHMAP=GrenadeIncenFirstPick NUM=1 TEXTURE=GrenadeIncenBodyPick

//3rd Person
#exec MESHMAP SETTEXTURE MESHMAP=GrenadeIncenFirst3rd NUM=1 TEXTURE=GrenadeIncenBodyPick

simulated function SpawnGrenade(float grenadeSpeed)
{
	Local Grenade_IncenProj Grenade;
	local vector StartLoc, FireLocation, X, Y, Z;

	GetAxes(Pawn(Owner).ViewRotation,X,Y,Z);
	StartLoc = Owner.Location + CSSCalcDrawOffset(); 
	FireLocation = StartLoc + ThrowOffset.X * X + ThrowOffset.Y * Y + ThrowOffset.Z * Z; 
	Grenade = Spawn(class'Grenade_IncenProj',,, FireLocation, Pawn(Owner).ViewRotation);
	Grenade.Speed = grenadeSpeed;
	Grenade.SpawnGrenade();
}

defaultproperties
{
	AmmoName=Class'BRUT.AmmoGrenade_Incen'
	PickupMessage="You got an Incendiary Grenade"
	ItemName="Incendiary Grenade"
	Icon=Texture'BRUT.GrenadeFlash.GFlashIcon'
	StatusIcon=Texture'BRUT.GrenadeFlash.GFlashIcon'
	AmmoName=Class'BRUT.AmmoGrenade_Incen'
	PlayerViewMesh=SkeletalMesh'BRUT.GrenadeIncenMesh'
	PickupViewMesh=LodMesh'BRUT.GrenadeIncenFirstPick'
	ThirdPersonMesh=LodMesh'BRUT.GrenadeIncenFirst3rd'
	Mesh=LodMesh'BRUT.GrenadeIncenFirstPick'
}